import { Style } from '@nativescript/core';
import { TextFieldBase } from './textfield.common';
declare class MDCFilledTextFieldImpl extends MDCFilledTextField {
    _owner: WeakRef<TextField>;
    static initWithOwner(owner: TextField): MDCFilledTextFieldImpl;
    textRectForBounds(bounds: CGRect): CGRect;
    editingRectForBounds(bounds: CGRect): CGRect;
}
declare class MDCOutlinedTextFieldImpl extends MDCOutlinedTextField {
    _owner: WeakRef<TextField>;
    static initWithOwner(owner: TextField): MDCOutlinedTextFieldImpl;
    textRectForBounds(bounds: CGRect): CGRect;
    editingRectForBounds(bounds: CGRect): CGRect;
}
declare class MDCUnderlinedTextFieldImpl extends MDCUnderlinedTextField {
    _owner: WeakRef<TextField>;
    static initWithOwner(owner: TextField): MDCUnderlinedTextFieldImpl;
    textRectForBounds(bounds: CGRect): CGRect;
    editingRectForBounds(bounds: CGRect): CGRect;
}
declare module '@nativescript/core/ui/text-field' {
    interface TextField {
        textFieldShouldChangeCharactersInRangeReplacementString(textField: UITextField, range: NSRange, replacementString: string): boolean;
    }
}
export declare class TextField extends TextFieldBase {
    nativeViewProtected: MDCBaseTextField;
    nativeTextViewProtected: MDCBaseTextField;
    readonly style: Style & {
        variant: 'outline' | 'underline' | 'filled';
    };
    nsdigits?: NSCharacterSet;
    firstEdit: boolean;
    clearFocus(): void;
    requestFocus(): void;
    textFieldShouldChangeCharactersInRangeReplacementString(textField: UITextField, range: NSRange, replacementString: string): boolean;
    private mCanAutoSize;
    onMeasure(widthMeasureSpec: number, heightMeasureSpec: number): void;
    _getTextRectForBounds(bounds: CGRect, superResult: CGRect): CGRect;
    errorScheme: MDCContainerScheme;
    createNativeView(): MDCFilledTextFieldImpl | MDCOutlinedTextFieldImpl | MDCUnderlinedTextFieldImpl;
    blur(): void;
    setSelection(start: number, stop?: number): void;
}
export {};
